# 4 - Python's Static Methods
"""
    Static Methods are different than Class and Instance Methods.
    Static Methods are used like utilites.
    They can be called by the Class like Classname.method().
    You define a Class Method using @staticmethod.
"""

"""
    Let's say you want to find out someone's age before deciding if you want to create and instance of the class for them.
    The Class can have a Method, a Class Method, that can be used like a utility to find out an age of a person first without the need to create an instance of the class.
    In this example, we use a Class Method named "persons_age(...)" to get the age of a person.
"""

from datetime import date

class Person:
    number_of_class_instances = 0

    def __init__(self, name, age):
        self.name = name
        self.age = age
        Person.number_of_class_instances += 1
    
    #Static Method that returns the age of the person.
    @staticmethod
    def persons_age(year):
        today = date.today()
        age = today.year - birthdate.year - ((today.month, today.day) < (birthdate.month, birthdate.day))
        return age
       
birthdate = date(int(input("Please enter their birth year: ")), int(input("Please enter their birth month: ")), int(input("Please enter their birth day: ")))

#Invoke the Class Method "persons_age(...)" using the Class Name "Person".
age = Person.persons_age(birthdate)

print("Age:", age)


""" Table illustrating the differences between class methods and instance methods.

      FEATURES   |   CLASS METHODS     |   INSTANCE METHODS
      -----------------------------------------------------------------
      Binding    |   Class             |   An instance of the class
      Calling    |   Class.method()    |   object.method()
      Accessing  |   Class attributes  |   Instance & class attributes

"""

""" Review: Method Arguments
                                                                           
    1) Instance method: receives the instance as first argument (self). EX: def print_profile(self):

                                               
    2) Class method: receives the class as first argument (cls).        EX: @classmethod
                                                                            def designer(cls, name, team):
                                          
    3) Static method: doesn’t receive any special arguments.            EX: @staticmethod
                                                                            def persons_age(year):
"""