# 6 - Inheritance
"""
    Inheritance is when a Sub Class inherits from another Class.
    This reduces the amount of code written, helps maintain integery, and makes code easier to maintain over time.
    In the example, Designer, Developer, and Tester inherit the Person Class.
"""

class Person:
    number_of_class_instances = 0

    def __init__(self, name, team, role):
        self.name = name
        self.team = team
        self.role = role
        Person.number_of_class_instances += 1

    def person(self):
        return f'Name: "{self.name}"\nTeam: "{self.team}"\nRole: "{self.role}"'
    
    
class Designer(Person):
    _software = ''

    def __init__(self, name, team):
        super().__init__(name, team, "Designer")

    @property
    def software(self):
        return f'Software: "{self._software}"'

    @software.setter
    def software(self, list_of_software):
        self._software = list_of_software

    def __str__(self):
        return f'{super().person()}\n{self.software}'

class Developer(Person):
    def __init__(self, name, team):
        super().__init__(name, team, "Developer")

    @property
    def languages(self):
        return f'Languages: "{self._languages}"'

    @languages.setter
    def languages(self, list_of_languages):
        self._languages = list_of_languages

    def __str__(self):
        return f'{super().person()}\n{self.languages}'

class Tester(Person):
    def __init__(self, name, team):
        super().__init__(name, team, "Tester")

    @property
    def tools(self):
        return f'Tools: "{self._tools}"'

    @tools.setter
    def tools(self, list_of_tools):
        self._tools = list_of_tools

    def __str__(self):
        return f'{super().person()}\n{self.tools}'

our_designer = Designer("John", "Team 1")
our_designer.software = "Adobe Photoshop, Figma, Hand Drawing"

our_developer = Developer("Robin", "Team 2")
our_developer.languages = "Python, C++, C#"

our_tester = Tester("Jake", "Team 3")
our_tester.tools = "Selimun, QTP, JAWS, NVDA"

for x in sorted((our_designer, our_developer, our_tester), key=lambda Person: Person.name):
    print(f'\n{x}')