# 7 - Encapsulation
"""
    Encapsulation is the process of preventing clients from accessing certain properties, which can only be accessed through specific methods.
    Because ther may be rules associated with data, controling what and how the user/programmer can data needs to be controlled.
"""

class Person:
    number_of_class_instances = 0

    def __init__(self, name, age):
        self.name = name
        self.age = age
        Person.number_of_class_instances += 1

    #This is the getter for name
    @property
    def name(self):
        return f"Name: {self._name}"

    #This is a setter for name
    @name.setter
    def name(self, name):
        self._name = name

    #This is the getter for age
    @property
    def age(self):
        return f"Age: {self._age}"

    #This is a setter for name
    @age.setter
    def age(self, age):
        self._age = age

    def __str__(self):
        #Calls the name and age getter
        return f"{self.name} {self.age}"

#Create instances (objects) of the Person Class and assign the name and an age.
my_friend_1 = Person('Scott', 28)
my_friend_2 = Person('Alex', 26)
my_friend_3 = Person('Amy', 25)

#Lambda functions, also known as anonymous functions, are small, one-time-use functions in Python. Read more: https://www.freecodecamp.org/news/python-lambda-functions/
for x in sorted((my_friend_1, my_friend_2, my_friend_3), key=lambda Person: Person.name):
    print(x)